<template>
  <Disclosure as="nav" class="bg-white shadow" v-slot="{ open }">
    <div class="mx-auto max-w-7xl px-2 sm:px-4 lg:px-8">
      <div class="flex h-16 justify-between">
        <div class="flex px-2 lg:px-0">
          <div class="flex flex-shrink-0 items-center">
            <Logo class="w-16 h-16"/>
          </div>
          <div class="flex flex-1 items-center justify-center px-2 lg:ml-6">
            <div class="relative w-full max-w-lg lg:max-w-xs">
              <label for="search" class="sr-only">Search</label>
              <div class="relative">
                <div class="pointer-events-none absolute inset-y-0 left-0 flex items-center pl-3">
                  <MagnifyingGlassIcon class="h-5 w-5 text-gray-400" aria-hidden="true"/>
                </div>
                <input id="search" name="search" @input="debounceSearch"
                       class="block w-full rounded-md border border-gray-300 bg-white py-2 pl-10 pr-3 leading-5 placeholder-gray-500 focus:border-indigo-500 focus:placeholder-gray-400 focus:outline-none focus:ring-1 focus:ring-indigo-500 sm:text-sm text-main"
                       placeholder="Search" type="search"/>
              </div>
              <div v-if="searchResult.length"
                   class="w-full max-w-lg lg:max-w-xs max-h-52 bg-white absolute overflow-scroll z-50 shadow-xl rounded-md mt-1">
                <div v-for="manga in searchResult" @click="goTo(manga)"
                     class="px-2 py-2 cursor-pointer hover:bg-gray-50 hover:text-main">{{ manga.title }}
                </div>
              </div>
            </div>
          </div>
          <div class="hidden lg:ml-6 lg:flex lg:space-x-8 lg:justify-end">
            <!-- Current: "border-indigo-500 text-gray-900", Default: "border-transparent text-gray-500 hover:border-gray-300 hover:text-gray-700" -->
            <router-link to="/" :class="active('Home') ? activeLink : inactiveLink"
                         class="inline-flex items-center border-b-2 px-1 pt-1 text-sm font-medium">Home
            </router-link>
            <router-link v-if="connected" to="/library" :class="active('Library') ?  activeLink : inactiveLink"
                         class="inline-flex items-center border-b-2 px-1 pt-1 text-sm font-medium">Library
            </router-link>
            <router-link to="/discover" :class="active('Discover') ? activeLink : inactiveLink"
                         class="inline-flex items-center border-b-2 px-1 pt-1 text-sm font-medium">Discover
            </router-link>
          </div>
        </div>
        <div class="flex items-center lg:hidden">
          <!-- Mobile menu button -->
          <DisclosureButton
              class="inline-flex items-center justify-center rounded-md p-2 text-gray-400 hover:bg-gray-100 hover:text-gray-500 focus:outline-none focus:ring-2 focus:ring-inset focus:ring-indigo-500">
            <span class="sr-only">Open main menu</span>
            <Bars3Icon v-if="!open" class="block h-6 w-6" aria-hidden="true"/>
            <XMarkIcon v-else class="block h-6 w-6" aria-hidden="true"/>
          </DisclosureButton>
        </div>
        <div class="hidden lg:ml-4 lg:flex lg:items-center">
          <button type="button"
                  class="flex-shrink-0 rounded-full bg-white p-1 text-gray-400 hover:text-gray-500 focus:outline-none focus:ring-2 focus:ring-indigo-500 focus:ring-offset-2">
            <span class="sr-only">View notifications</span>
          </button>

          <!-- Profile dropdown -->
          <Menu v-if="$store.auth" as="div" class="relative ml-4 flex-shrink-0">
            <div class="flex items-center">
              <span class="mr-4 text-main text-sm" v-if="$store?.user?.pseudo">{{$store.user.pseudo}}</span>
              <MenuButton
                  class="flex rounded-full bg-white text-sm focus:outline-none focus:ring-2 focus:ring-indigo-500 focus:ring-offset-2">
                <span class="sr-only">Open user menu</span>
                <img class="h-8 w-8 rounded-full"
                     src="https://images.unsplash.com/photo-1581833971358-2c8b550f87b3?ixlib=rb-4.0.3&ixid=MnwxMjA3fDB8MHxwaG90by1wYWdlfHx8fGVufDB8fHx8&auto=format&fit=crop&w=2071&q=80"
                     alt=""/>
              </MenuButton>
            </div>
            <transition enter-active-class="transition ease-out duration-100"
                        enter-from-class="transform opacity-0 scale-95" enter-to-class="transform opacity-100 scale-100"
                        leave-active-class="transition ease-in duration-75"
                        leave-from-class="transform opacity-100 scale-100"
                        leave-to-class="transform opacity-0 scale-95">
              <MenuItems
                  class="absolute right-0 z-10 mt-2 w-48 origin-top-right rounded-md bg-white py-1 shadow-lg ring-1 ring-black ring-opacity-5 focus:outline-none">
                <MenuItem v-slot="{ active }" v-if="connected">
                  <button @click="logout"
                          :class="[active ? 'bg-gray-100' : '', 'block px-4 py-2 text-sm text-gray-700']">Sign out
                  </button>
                </MenuItem>
                <MenuItem v-slot="{ active }" v-else>
                  <router-link to="/login"
                               :class="[active ? 'bg-gray-100' : '', 'block px-4 py-2 text-sm text-gray-700']">Sign In /
                    Register
                  </router-link>
                </MenuItem>
              </MenuItems>
            </transition>
          </Menu>
          <router-link v-else to="/login" class="flex px-6 justify-center bg-[#A370F0] rounded-[0.9em] text-white text-sm py-3 rounded-lg">Sign In /
            Register
          </router-link>
        </div>
      </div>
    </div>

    <DisclosurePanel class="lg:hidden">
      <div class="space-y-1 pt-2 pb-3">
        <!-- Current: "bg-indigo-50 border-indigo-500 text-indigo-700", Default: "border-transparent text-gray-600 hover:bg-gray-50 hover:border-gray-300 hover:text-gray-800" -->
        <router-link to="/" :class="active('Home') ?  activeLink : inactiveLink"
                     class="inline-flex items-center px-1 pt-1 text-sm font-medium">Home
        </router-link>
        <router-link v-if="connected" to="/library" :class="active('Library') ?  activeLink : inactiveLink"
                     class="inline-flex items-center border-b-2 border-transparent px-1 pt-1 text-sm font-medium">
          Library
        </router-link>
        <router-link to="/discover" :class="active('Discover') ?  activeLink : inactiveLink"
                     class="inline-flex items-center border-b-2 border-transparent px-1 pt-1 text-sm font-medium">
          Discover
        </router-link>
      </div>
      <div class="border-t border-gray-200 pt-4 pb-3">
        <div class="flex items-center px-4">
          <div class="flex-shrink-0">
            <img class="h-10 w-10 rounded-full"
                 src="https://images.unsplash.com/photo-1472099645785-5658abf4ff4e?ixlib=rb-1.2.1&ixid=eyJhcHBfaWQiOjEyMDd9&auto=format&fit=facearea&facepad=2&w=256&h=256&q=80"
                 alt=""/>
          </div>
          <div class="ml-3">
            <div class="text-base font-medium text-gray-800">Tom Cook</div>
            <div class="text-sm font-medium text-gray-500">tom@example.com</div>
          </div>
          <button type="button"
                  class="ml-auto flex-shrink-0 rounded-full bg-white p-1 text-gray-400 hover:text-gray-500 focus:outline-none focus:ring-2 focus:ring-indigo-500 focus:ring-offset-2">
            <span class="sr-only">View notifications</span>
          </button>
        </div>
        <div class="mt-3 space-y-1">
          <router-link to="#"
                       class="block px-4 py-2 text-base font-medium text-gray-500 hover:bg-gray-100 hover:text-gray-800">
            Your Profile
          </router-link>
          <router-link to="#"
                       class="block px-4 py-2 text-base font-medium text-gray-500 hover:bg-gray-100 hover:text-gray-800">
            Settings
          </router-link>
          <router-link to="/login"
                       class="block px-4 py-2 text-base font-medium text-gray-500 hover:bg-gray-100 hover:text-gray-800">
            Sign out
          </router-link>
          <router-link to="/login"
                       class="block px-4 py-2 text-base font-medium text-gray-500 hover:bg-gray-100 hover:text-gray-800">
            Sign In
          </router-link>
        </div>
      </div>
    </DisclosurePanel>
  </Disclosure>
</template>

<script setup>
import {Disclosure, DisclosureButton, DisclosurePanel, Menu, MenuButton, MenuItem, MenuItems} from '@headlessui/vue'
import {MagnifyingGlassIcon} from '@heroicons/vue/20/solid'
import {Bars3Icon, XMarkIcon} from '@heroicons/vue/24/outline'
import Logo from "../components/Logo.vue";</script>

<script>
export default {
  name: "Navbar",

  data() {
    return {
      inactiveLink: 'hover:border-gray-300 hover:text-gray-700 text-gray-500',
      activeLink: 'border-indigo-500 text-gray-900',
      search: null,
      loading: false,
      searchResult: []
    }
  },

  methods: {
    logout() {
      this.$axios.get('/logout', {
        headers: {
          'Access-Control-Allow-Origin': 'http://localhost* , http://127.0.0.1*',
          'Authorization': this.$store.userToken
        }
      }).then((response) => {
        this.$store.removeUser()
      }).catch((res) => {
        console.log(res)
      })
    },

    debounceSearch(event) {
      this.search = null
      this.loading = true
      clearTimeout(this.debounce)
      this.debounce = setTimeout(() => {
        this.loading = false
        this.search = event.target.value
        if (!this.search.length) {
          this.searchResult = []
        } else {
          this.searchManga()
        }

      }, 600)
    },

    searchManga() {
      this.$axios.get(`https://api.consumet.org/manga/mangadex/${this.search}`).then(({data, status}) => {
        this.searchResult = data.results.filter(result => !result.title.toLowerCase().includes('doujinshi'))
      })
    },

    async goTo(mangaData) {
      console.log(mangaData)

      await this.$axios.get(`/mangas/exists/${mangaData.id}`)
      const exists = (await this.$axios.get(`/mangas/exists/${mangaData.id}`)).data

      console.log(exists)
      if(exists){
        this.searchResult = []
        this.search = null
        this.$router.push({path: `/`})
        this.$router.push({path: `/mangas/${mangaData.id}`})
      }else{
        this.createManga(mangaData)
      }

    },

    createManga(mangaData){
      this.$axios.get(`https://api.consumet.org/manga/mangadex/info/${mangaData.id}`).then(({data}) => {
        const manga = {}

        manga.api_id = mangaData.id
        manga.title = data.title
        manga.chapters = data.chapters?.length
        manga.release_date = data.releaseDate
        manga.picture = data.image
        manga.status = data.status
        manga.themes = data.themes
        manga.genres = data.genres
        manga.description = data.description?.en ?? ''

        manga.volumes = Math.ceil(manga.chapters / 9.5)

        if (manga.description.length > 400) {
          manga.description = manga.description.slice(0, 397) + "..."
        }

        const japTitleArr = data.altTitles.map(title => Object.values(title)[0]).filter(title => title.match(/[\u3000-\u303f\u3040-\u309f\u30a0-\u30ff\uff00-\uff9f\u4e00-\u9faf\u3400-\u4dbf]/))
        if (japTitleArr.length) {
          manga.jap_title = japTitleArr[0]
        }else{
          let hasColumn = manga.title.includes(':')
          manga.jap_title = hasColumn ? manga.title.split(':')[0] : manga.title.split(' ')[0]
        }

        const params = new URLSearchParams();
        params.append('manga', JSON.stringify(manga));

        this.$axios.post('/mangas', params, {
          headers: {'Access-Control-Allow-Origin': 'http://localhost* , http://127.0.0.1*'}
        }).then(({status}) => {
          if (status === 201) {
            this.searchResult = []
            this.search = null
            this.$router.push({path: `/mangas/${mangaData.id}`})
          }
        })
      })
    }
  },

  computed: {
    active() {
      return (route = 'Home') => {
        return route === this.$route.name
      }
    },
    connected() {
      return this.$store.auth
    }
  },
}
</script>